package com.jpattern.orm;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;

import com.jpattern.orm.dialect.DerbyDialect;
import com.jpattern.orm.test.AutoIdTest;
import com.jpattern.orm.test.EmployeeTest;
import com.jpattern.orm.test.IJpOrmTestsConstants;
import com.jpattern.orm.test.WrapperTypeTableTest;
import com.jpattern.orm.test.crud.OrmCRUDQueryGeneratorTest;
import com.jpattern.orm.test.mapper.ClassMapperGeneratorTest;
import com.jpattern.orm.test.query.QueryExecutionTest;
import com.jpattern.orm.test.query.forupdate.QuerySelectForUpdateExecutionTest;
import com.jpattern.orm.test.transaction.EmployeeTransactionTest;
import com.jpattern.orm.test.version.VersionTest;

/**
 * 
 * @author Francesco Cina
 * 
 *         20/mag/2011
 */
@RunWith(Suite.class)
@Suite.SuiteClasses({
	EmployeeTest.class,
	ClassMapperGeneratorTest.class,
	EmployeeTransactionTest.class,
	QueryExecutionTest.class,
	AutoIdTest.class,
	QuerySelectForUpdateExecutionTest.class,
	OrmCRUDQueryGeneratorTest.class,
	VersionTest.class,
	WrapperTypeTableTest.class


	// There are problems with Derby's generated key logic, then transactions do not work.
	//	PeopleMultipleTest.class,
	//	PeopleTest.class,
	//	ScriptExecutorTest.class,
	//	JdbcTemplatePeopleTest.class,
})
public class ComplianceDERBYTests {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		BaseTestShared.init(SessionProviderProxy.getSessionsProvider().getDerbySessionProvider(),
				IJpOrmTestsConstants.DERBY_CREATE_SCRIPT,
				IJpOrmTestsConstants.DERBY_DROP_SCRIPT,
				new DerbyDialect(),
				SessionProviderProxy.getGeneratorStrategy());
	}

}
