package com.jpattern.orm.test.domain;

import java.sql.ResultSet;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.generator.IOrmPersistor;

/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 */
public class EmployeePersistor implements IOrmPersistor<Employee> {

	/**
	 * 
	 */


	@Override
	public Employee mapRow(String rowNamePrefix, ResultSet rs, int rowNum) {
		final Employee employee = new Employee();
		try {
			employee.setId( rs.getInt(rowNamePrefix + "ID") );
			employee.setAge( rs.getInt(rowNamePrefix + "AGE") );
			employee.setEmployeeNumber( rs.getString(rowNamePrefix + "EMPLOYEE_NUMBER") );
			employee.setName( rs.getString(rowNamePrefix + "NAME") );
			employee.setSurname( rs.getString(rowNamePrefix + "SURNAME") );
		} catch (final Exception e) {
			throw new OrmException(e);
		}
		return employee;
	}

	@Override
	public Object[] allValues(Employee entity) {
		final Object[] result = new Object[]{entity.getId(), entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()};
		return result;
	}

	@Override
	public Object[] primaryKeyValues(Employee entity) {
		final Object[] result = new Object[]{entity.getId()};
		return result;
	}

	@Override
	public Object[] notPrimaryKeyValues(Employee entity) {
		final Object[] result = new Object[]{ entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()};
		return result;
	}

	@Override
	public void updateGeneratedValues(ResultSet rs, Employee entity) {
		try {
			entity.setId( rs.getInt(1) );
			entity.setAge( rs.getInt(2) );
		} catch (final Exception e) {
			throw new OrmException(e);
		}
	}

	@Override
	public Object[] allNotGeneratedValues(Employee entity) {
		final Object[] result = new Object[]{entity.getId(), entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()};
		return result;
	}

	@Override
	public void increaseVersion(Employee entity, boolean firstVersionNumber) {
	}

	@Override
	public Object[] primaryKeyAndVersionValues(Employee entity) {
		return primaryKeyValues(entity);
	}

	@Override
	public boolean useKeyGenerators(Employee entity) {
		return false;
	}

}
