package com.jpattern.orm.test.session;

import org.junit.Test;

import com.jpattern.orm.BaseTestShared;
import com.jpattern.orm.classtool.NullOrmClassToolMap;
import com.jpattern.orm.generator.ResultSetMethodHelper;
import com.jpattern.orm.session.Session;
import com.jpattern.orm.session.SessionProvider;
import com.jpattern.orm.session.OrmSession;
import com.jpattern.orm.transaction.ITransaction;

/**
 * 
 * @author Francesco Cina
 *
 * 05/giu/2011
 */
public class DataSourceConnectionTest extends BaseTestShared {

	@Override
	protected void setUp() throws Exception {
	}

	@Override
	protected void tearDown() throws Exception {
	}

	@Test
	public void testConnections() throws Exception {
		final SessionProvider provider = getJPOrm().getSessionProvider();
		loopTransaction( provider );
		loopConnection( provider );
	}

	public void loopTransaction(SessionProvider dsProvider) throws Exception {
		final Session conn = new OrmSession(new NullOrmClassToolMap(), dsProvider.getSessionStrategy(), new ResultSetMethodHelper());

		final int howMany = 1000;

		for (int i=0; i<howMany; i++) {
			final ITransaction tx = conn.transaction();
			tx.commit();
			System.out.println("commit: " + i);
		}

		for (int i=0; i<howMany; i++) {
			final ITransaction tx = conn.transaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}

	public void loopConnection(SessionProvider dsProvider) throws Exception {

		final int howMany = 100;

		for (int i=0; i<howMany; i++) {
			final Session conn = new OrmSession(new NullOrmClassToolMap(), dsProvider.getSessionStrategy(), new ResultSetMethodHelper());
			final ITransaction tx = conn.transaction();
			tx.commit();
			System.out.println("commit: " + i);
		}

		for (int i=0; i<howMany; i++) {
			final Session conn = new OrmSession(new NullOrmClassToolMap(), dsProvider.getSessionStrategy(), new ResultSetMethodHelper());
			final ITransaction tx = conn.transaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}
}
